# Copyright (c) Meta Platforms, Inc. and affiliates.
#
# This source code is licensed under the MIT license found in the
# LICENSE file in the root directory of this source tree.
from enum import Enum
from pathlib import Path
from typing import Iterable, Type

from learning_to_style_check.libcst._batched_visitor import BatchableCSTVisitor, visit_batched
from learning_to_style_check.libcst._exceptions import MetadataException, ParserSyntaxError
from learning_to_style_check.libcst._flatten_sentinel import FlattenSentinel
from learning_to_style_check.libcst._maybe_sentinel import MaybeSentinel
from learning_to_style_check.libcst._metadata_dependent import MetadataDependent
from learning_to_style_check.libcst._nodes.base import CSTNode, CSTValidationError
from learning_to_style_check.libcst._nodes.expression import (
    Annotation,
    Arg,
    Asynchronous,
    Attribute,
    Await,
    BaseAssignTargetExpression,
    BaseComp,
    BaseDelTargetExpression,
    BaseDict,
    BaseDictElement,
    BaseElement,
    BaseExpression,
    BaseFormattedStringContent,
    BaseList,
    BaseNumber,
    BaseSet,
    BaseSimpleComp,
    BaseSlice,
    BaseString,
    BinaryOperation,
    BinLow,
    BinUp,
    BooleanOperation,
    ByteLowStringPrefix,
    ByteUpStringPrefix,
    Call,
    Comparison,
    ComparisonTarget,
    CompFor,
    CompIf,
    ConcatenatedString,
    Dict,
    DictComp,
    DictElement,
    DoubleQuotesString,
    Element,
    Ellipsis,
    ExpLow,
    ExpUp,
    Float,
    FormattedString,
    FormattedStringExpression,
    FormattedStringText,
    From,
    GeneratorExp,
    HexadecimalLow,
    HexadecimalUp,
    HexadecimalMixed,
    HexLow,
    HexUp,
    IfExp,
    ImagLow,
    ImagUp,
    Index,
    Integer,
    Lambda,
    LeftCurlyBrace,
    LeftParen,
    LeftSquareBracket,
    List,
    ListComp,
    Name,
    NamedExpr,
    NumberNotation,
    OctLow,
    OctUp,
    Param,
    Parameters,
    ParamSlash,
    ParamStar,
    RightCurlyBrace,
    RightParen,
    RightSquareBracket,
    RawLowStringPrefix,
    RawUpStringPrefix,
    Set,
    SetComp,
    SimpleString,
    SingleQuotesString,
    Slice,
    StarredDictElement,
    StarredElement,
    String,
    Subscript,
    SubscriptElement,
    Tuple,
    TripleDoubleQuotesString,
    TripleSingleQuotesString,
    UnaryOperation,
    UnicodeLowStringPrefix,
    UnicodeUpStringPrefix,
    Yield,
    Number,
    NamePythonKeyword,
    NameLetterLow,
    NameLetterUp,
    NameLowercase,
    NameLowerCamelCase,
    NameLowerCamelCase2,
    NameUpperCamelCase,
    NameUpperCamelCase2,
    NameScreamingSnakeCase,
    NameSnakeCase,
    NameMagicName,
    NameSingleLeadingUnderscore,
    NameDoubleLeadingUnderscore,
    NameSingleTrailingUnderscore,
    NameDoubleTrailingUnderscore,
    FormattedLowStringPrefix,
    FormattedUpStringPrefix,
)
from learning_to_style_check.libcst._nodes.module import Module
from learning_to_style_check.libcst._nodes.op import (
    Add,
    AddAssign,
    And,
    AssignEqual,
    BaseAugOp,
    BaseBinaryOp,
    BaseBooleanOp,
    BaseCompOp,
    BaseUnaryOp,
    BitAnd,
    BitAndAssign,
    BitInvert,
    BitOr,
    BitOrAssign,
    BitXor,
    BitXorAssign,
    Colon,
    Comma,
    Divide,
    DivideAssign,
    Dot,
    Equal,
    FloorDivide,
    FloorDivideAssign,
    GreaterThan,
    GreaterThanEqual,
    ImportStar,
    In,
    Is,
    IsNot,
    LeftShift,
    LeftShiftAssign,
    LessThan,
    LessThanEqual,
    MatrixMultiply,
    MatrixMultiplyAssign,
    Minus,
    Modulo,
    ModuloAssign,
    Multiply,
    MultiplyAssign,
    Not,
    NotEqual,
    NotIn,
    Or,
    Plus,
    Power,
    PowerAssign,
    RightShift,
    RightShiftAssign,
    Semicolon,
    Subtract,
    SubtractAssign,
)
from learning_to_style_check.libcst._nodes.statement import (
    AnnAssign,
    AsName,
    Assert,
    Assign,
    AssignTarget,
    AugAssign,
    BaseCompoundStatement,
    BaseSmallStatement,
    BaseStatement,
    BaseSuite,
    Break,
    ClassDef,
    Continue,
    Decorator,
    Del,
    Else,
    ExceptHandler,
    ExceptStarHandler,
    Expr,
    Finally,
    For,
    FunctionDef,
    Global,
    If,
    IndentSpacing,
    Import,
    ImportAlias,
    ImportFrom,
    IndentedBlock,
    Match,
    MatchAs,
    MatchCase,
    MatchClass,
    MatchKeywordElement,
    MatchList,
    MatchMapping,
    MatchMappingElement,
    MatchOr,
    MatchOrElement,
    MatchPattern,
    MatchSequence,
    MatchSequenceElement,
    MatchSingleton,
    MatchStar,
    MatchTuple,
    MatchValue,
    NameItem,
    Nonlocal,
    Pass,
    Raise,
    Return,
    SimpleStatementLine,
    SimpleStatementSuite,
    Try,
    TryStar,
    While,
    With,
    WithItem,
)
from learning_to_style_check.libcst._nodes.whitespace import (
    BaseParenthesizableWhitespace,
    Comment,
    EmptyLine,
    Newline,
    ParenthesizedWhitespace,
    SimpleWhitespace,
    TrailingWhitespace,
    UnixNewline,
    WindowsNewline,
    MacNewline,
)
from learning_to_style_check.libcst._parser.entrypoints import parse_expression, parse_module, parse_statement
from learning_to_style_check.libcst._parser.types.config import (
    KNOWN_PYTHON_VERSION_STRINGS,
    PartialParserConfig,
)
from learning_to_style_check.libcst._removal_sentinel import RemovalSentinel, RemoveFromParent
from learning_to_style_check.libcst._visitors import CSTNodeT, CSTTransformer, CSTVisitor, CSTVisitorT

try:
    from learning_to_style_check.libcst._version import version as LIBCST_VERSION
except ImportError:
    LIBCST_VERSION = "unknown"
from learning_to_style_check.libcst.helpers import (  # from learning_to_style_check.libcst import ensure_type is deprecated, will be removed in 0.4.0
    ensure_type,
)
from learning_to_style_check.libcst.metadata.base_provider import (
    BaseMetadataProvider,
    BatchableMetadataProvider,
    VisitorMetadataProvider,
)
from learning_to_style_check.libcst.metadata.wrapper import MetadataWrapper

__all__ = [
    "KNOWN_PYTHON_VERSION_STRINGS",
    "LIBCST_VERSION",
    "BatchableCSTVisitor",
    "CSTNodeT",
    "CSTTransformer",
    "CSTValidationError",
    "CSTVisitor",
    "CSTVisitorT",
    "FlattenSentinel",
    "MaybeSentinel",
    "MetadataException",
    "ParserSyntaxError",
    "PartialParserConfig",
    "RemoveFromParent",
    "RemovalSentinel",
    "ensure_type",  # from learning_to_style_check.libcst import ensure_type is deprecated, will be removed in 0.4.0
    "visit_batched",
    "parse_module",
    "parse_expression",
    "parse_statement",
    "CSTNode",
    "Module",
    "Annotation",
    "Arg",
    "Asynchronous",
    "Attribute",
    "Await",
    "BaseAssignTargetExpression",
    "BaseComp",
    "BaseDelTargetExpression",
    "BaseDict",
    "BaseDictElement",
    "BaseElement",
    "BaseExpression",
    "BaseFormattedStringContent",
    "BaseList",
    "BaseNumber",
    "BaseSet",
    "BaseSimpleComp",
    "BaseSlice",
    "BaseString",
    "BinaryOperation",
    "BooleanOperation",
    "Call",
    "Comparison",
    "ComparisonTarget",
    "CompFor",
    "CompIf",
    "ConcatenatedString",
    "Dict",
    "DictComp",
    "DictElement",
    "Element",
    "Ellipsis",
    "Float",
    "FormattedString",
    "FormattedStringExpression",
    "FormattedStringText",
    "From",
    "GeneratorExp",
    "IfExp",
    "Index",
    "Integer",
    "Lambda",
    "LeftCurlyBrace",
    "LeftParen",
    "LeftSquareBracket",
    "List",
    "ListComp",
    "Name",
    "NamedExpr",
    "Param",
    "Parameters",
    "ParamSlash",
    "ParamStar",
    "RightCurlyBrace",
    "RightParen",
    "RightSquareBracket",
    "Set",
    "SetComp",
    "SimpleString",
    "Slice",
    "StarredDictElement",
    "StarredElement",
    "Subscript",
    "SubscriptElement",
    "Tuple",
    "UnaryOperation",
    "Yield",
    "Add",
    "AddAssign",
    "And",
    "AssignEqual",
    "BaseAugOp",
    "BaseBinaryOp",
    "BaseBooleanOp",
    "BaseCompOp",
    "BaseUnaryOp",
    "BitAnd",
    "BitAndAssign",
    "BitInvert",
    "BitOr",
    "BitOrAssign",
    "BitXor",
    "BitXorAssign",
    "Colon",
    "Comma",
    "Divide",
    "DivideAssign",
    "Dot",
    "Equal",
    "FloorDivide",
    "FloorDivideAssign",
    "GreaterThan",
    "GreaterThanEqual",
    "ImportStar",
    "In",
    "Is",
    "IsNot",
    "LeftShift",
    "LeftShiftAssign",
    "LessThan",
    "LessThanEqual",
    "MatrixMultiply",
    "MatrixMultiplyAssign",
    "Minus",
    "Modulo",
    "ModuloAssign",
    "Multiply",
    "MultiplyAssign",
    "Not",
    "NotEqual",
    "NotIn",
    "Or",
    "Plus",
    "Power",
    "PowerAssign",
    "RightShift",
    "RightShiftAssign",
    "Semicolon",
    "Subtract",
    "SubtractAssign",
    "AnnAssign",
    "AsName",
    "Assert",
    "Assign",
    "AssignTarget",
    "AugAssign",
    "BaseCompoundStatement",
    "BaseSmallStatement",
    "BaseStatement",
    "BaseSuite",
    "Break",
    "ClassDef",
    "Continue",
    "Decorator",
    "Del",
    "Else",
    "ExceptHandler",
    "ExceptStarHandler",
    "Expr",
    "Finally",
    "For",
    "FunctionDef",
    "Global",
    "If",
    "Import",
    "ImportAlias",
    "ImportFrom",
    "IndentedBlock",
    "Match",
    "MatchCase",
    "MatchAs",
    "MatchClass",
    "MatchKeywordElement",
    "MatchList",
    "MatchMapping",
    "MatchMappingElement",
    "MatchOr",
    "MatchOrElement",
    "MatchPattern",
    "MatchSequence",
    "MatchSequenceElement",
    "MatchSingleton",
    "MatchStar",
    "MatchTuple",
    "MatchValue",
    "NameItem",
    "Nonlocal",
    "Pass",
    "Raise",
    "Return",
    "SimpleStatementLine",
    "SimpleStatementSuite",
    "Try",
    "TryStar",
    "While",
    "With",
    "WithItem",
    "BaseParenthesizableWhitespace",
    "Comment",
    "EmptyLine",
    "Newline",
    "ParenthesizedWhitespace",
    "SimpleWhitespace",
    "TrailingWhitespace",
    "BaseMetadataProvider",
    "BatchableMetadataProvider",
    "VisitorMetadataProvider",
    "MetadataDependent",
    "MetadataWrapper",
    "TripleDoubleQuotesString",
    "String",
    "UnixNewline",
    "WindowsNewline",
    "MacNewline",
    "FormattedLowStringPrefix",
    "FormattedUpStringPrefix",
]


class NameStyle(str, Enum):
    LetterLow = "LetterLow"
    LetterUp = "LetterUp"
    Lowercase = "Lowercase"
    LowerCamelCase = "LowerCamelCase"
    LowerCamelCase2 = "LowerCamelCase2"
    UpperCamelCase = "UpperCamelCase"
    UpperCamelCase2 = "UpperCamelCase2"
    ScreamingSnakeCase = "ScreamingSnakeCase"
    SnakeCase = "SnakeCase"
    MagicName = "MagicName"

    def get_node_class(self) -> Type["CSTNode"]:
        if self.value == "LetterLow":
            return NameLetterLow
        elif self.value == "LetterUp":
            return NameLetterUp
        elif self.value == "Lowercase":
            return NameLowercase
        elif self.value == "LowerCamelCase":
            return NameLowerCamelCase
        elif self.value == "LowerCamelCase2":
            return NameLowerCamelCase2
        elif self.value == "UpperCamelCase":
            return NameUpperCamelCase
        elif self.value == "UpperCamelCase2":
            return NameUpperCamelCase2
        elif self.value == "ScreamingSnakeCase":
            return NameScreamingSnakeCase
        elif self.value == "SnakeCase":
            return NameSnakeCase
        elif self.value == "MagicName":
            return NameMagicName
        else:
            raise Exception(f"Unknown NameStyle: {self.value}")


class NameStylePrefix(str, Enum):
    SingleLeadingUnderscore = "SingleLeadingUnderscore"
    DoubleLeadingUnderscore = "DoubleLeadingUnderscore"

    def get_node_class(self) -> Type["CSTNode"]:
        if self.value == "SingleLeadingUnderscore":
            return NameSingleLeadingUnderscore
        elif self.value == "DoubleLeadingUnderscore":
            return NameDoubleLeadingUnderscore
        else:
            raise Exception(f"Unknown NameStylePrefix: {self.value}")


class NameStyleSuffix(str, Enum):
    SingleTrailingUnderscore = "SingleTrailingUnderscore"
    DoubleTrailingUnderscore = "DoubleTrailingUnderscore"

    def get_node_class(self) -> Type["CSTNode"]:
        if self.value == "SingleTrailingUnderscore":
            return NameSingleTrailingUnderscore
        elif self.value == "DoubleTrailingUnderscore":
            return NameDoubleTrailingUnderscore
        else:
            raise Exception(f"Unknown NameStyleSuffix: {self.value}")


NODE_NAMES = [
    "Add",
    "AddAssign",
    "And",
    "AnnAssign",
    "Annotation",
    "Arg",
    "AsName",
    "Assert",
    "Assign",
    "AssignEqual",
    "AssignTarget",
    "Asynchronous",
    "Attribute",
    "AugAssign",
    "Await",
    "BinLow",
    "BinUp",
    "Binary",
    "BinaryOperation",
    "BitAnd",
    "BitAndAssign",
    "BitInvert",
    "BitOr",
    "BitOrAssign",
    "BitXor",
    "BitXorAssign",
    "BooleanOperation",
    "Break",
    "ByteLowStringPrefix",
    "ByteUpStringPrefix",
    "Call",
    "ClassDef",
    "Colon",
    "Comma",
    "Comment",
    "CompFor",
    "CompIf",
    "Comparison",
    "ComparisonTarget",
    "ConcatenatedString",
    "Continue",
    "Decorator",
    "Del",
    "Dict",
    "DictComp",
    "DictElement",
    "Divide",
    "DivideAssign",
    "Dot",
    "DoubleQuotesString",
    "Element",
    "Ellipsis",
    "Else",
    "EmptyLine",
    "EncodingComment",
    "Equal",
    "ExceptHandler",
    "ExceptStarHandler",
    "ExpLow",
    "ExpUp",
    "Expr",
    "Finally",
    "Float",
    "FloorDivide",
    "FloorDivideAssign",
    "For",
    "FormattedLowStringPrefix",
    "FormattedString",
    "FormattedStringExpression",
    "FormattedStringText",
    "FormattedUpStringPrefix",
    "From",
    "FunctionDef",
    "GeneratorExp",
    "Global",
    "GreaterThan",
    "GreaterThanEqual",
    "HexLow",
    "HexUp",
    "HexadecimalLow",
    "HexadecimalMixed",
    "HexadecimalUp",
    "If",
    "IfExp",
    "ImagLow",
    "ImagUp",
    "Import",
    "ImportAlias",
    "ImportFrom",
    "ImportStar",
    "In",
    "IndentSpacing",
    "IndentedBlock",
    "IndentedBlockEnd",
    "Index",
    "Integer",
    "Is",
    "IsNot",
    "Lambda",
    "LeftCurlyBrace",
    "LeftParen",
    "LeftShift",
    "LeftShiftAssign",
    "LeftSquareBracket",
    "Length1",
    "Length2",
    "Length4",
    "LessThan",
    "LessThanEqual",
    "List",
    "ListComp",
    "MacNewline",
    "Match",
    "MatchAs",
    "MatchCase",
    "MatchClass",
    "MatchKeywordElement",
    "MatchList",
    "MatchMapping",
    "MatchMappingElement",
    "MatchOr",
    "MatchOrElement",
    "MatchSequenceElement",
    "MatchSingleton",
    "MatchStar",
    "MatchTuple",
    "MatchValue",
    "MatrixMultiply",
    "MatrixMultiplyAssign",
    "Minus",
    "Module",
    "Modulo",
    "ModuloAssign",
    "Multiply",
    "MultiplyAssign",
    "NameDoubleLeadingUnderscore",
    "NameDoubleTrailingUnderscore",
    "NameItem",
    "NameLetterLow",
    "NameLetterUp",
    "NameLowerCamelCase",
    "NameLowerCamelCase2",
    "NameLowercase",
    "NameMagicName",
    "NamePythonKeyword",
    "NameScreamingSnakeCase",
    "NameSingleLeadingUnderscore",
    "NameSingleTrailingUnderscore",
    "NameSnakeCase",
    "NameUndefinedPattern",
    "NameUpperCamelCase",
    "NameUpperCamelCase2",
    "NamedExpr",
    "Nonlocal",
    "Not",
    "NotEqual",
    "NotIn",
    "Number",
    "NumberUnderscore",
    "OctLow",
    "OctUp",
    "Or",
    "Param",
    "ParamSlash",
    "ParamStar",
    "Parameters",
    "ParenthesizedWhitespace",
    "Pass",
    "Plus",
    "Power",
    "PowerAssign",
    "Raise",
    "RawLowStringPrefix",
    "RawUpStringPrefix",
    "Return",
    "RightCurlyBrace",
    "RightParen",
    "RightShift",
    "RightShiftAssign",
    "RightSquareBracket",
    "Semicolon",
    "Set",
    "SetComp",
    "ShebangComment",
    "ShebangEnvComment",
    "ShebangPython3Comment",
    "ShebangPythonComment",
    "SimpleStatementLine",
    "SimpleStatementSuite",
    "SimpleString",
    "SimpleWhitespace",
    "SingleQuotesString",
    "Slice",
    "Spacing1Space",
    "Spacing1Tab",
    "Spacing2Space",
    "Spacing2Tab",
    "Spacing4Space",
    "Spacing4Tab",
    "SpacingLineContinuation",
    "StarredDictElement",
    "StarredElement",
    "Subscript",
    "SubscriptElement",
    "Subtract",
    "SubtractAssign",
    "TrailingWhitespace",
    "TripleDoubleQuotesString",
    "TripleSingleQuotesString",
    "Try",
    "TryStar",
    "Tuple",
    "UnaryOperation",
    "UnicodeLowStringPrefix",
    "UnicodeUpStringPrefix",
    "UnixNewline",
    "While",
    "WindowsNewline",
    "With",
    "WithItem",
    "Yield"
]

VISUAL_NODE_NAMES = [
    "Annotation",
    "BinLow",
    "BinUp",
    "ByteLowStringPrefix",
    "ByteUpStringPrefix",
    "DoubleQuotesString",
    "ExpLow",
    "ExpUp",
    "FormattedLowStringPrefix",
    "FormattedUpStringPrefix",
    "HexLow",
    "HexUp",
    "HexadecimalLow",
    "HexadecimalMixed",
    "HexadecimalUp",
    "ImagLow",
    "ImagUp",
    "MacNewline",
    "NameLetterLow",
    "NameLetterUp",
    "NameLowerCamelCase",
    "NameLowerCamelCase2",
    "NameLowercase",
    "NameMagicName",
    "NamePythonKeyword",
    "NameScreamingSnakeCase",
    "NameSingleLeadingUnderscore",
    "NameSingleTrailingUnderscore",
    "NameSnakeCase",
    "NameUndefinedPattern",
    "NameUpperCamelCase",
    "NameUpperCamelCase2",
    "NumberUnderscore",
    "OctLow",
    "OctUp",
    "RawLowStringPrefix",
    "RawUpStringPrefix",
    "SingleQuotesString",
    "Spacing1Space",
    "Spacing1Tab",
    "Spacing2Space",
    "Spacing2Tab",
    "Spacing4Space",
    "Spacing4Tab",
    "TripleDoubleQuotesString",
    "TripleDoubleQuotesString",
    "TripleSingleQuotesString",
    "TripleSingleQuotesString",
    "UnicodeLowStringPrefix",
    "UnicodeUpStringPrefix",
    "UnixNewline",
    "WindowsNewline"
]


def get_all_node_class_names() -> Iterable[str]:
    """
    Returns a list of all node class names in libcst.
    All visible nodes have dataclass decorators.
    """
    ignore_files = [
        "__init__.py",
        "base.py",
        "internal.py",
    ]
    nodes = []
    for p in Path(__file__).parent.glob("_nodes/*.py"):
        if p.name in ignore_files:
            continue
        with p.open() as f:
            code = f.read()

        code = code.split("\n")

        for i, row in enumerate(code):
            if row.startswith("@dataclass"):
                nodes.append(code[i + 1].split("class ")[1].split("(")[0])

    return nodes
